/* Motenpoche 
 *
 * (c) 2023 Daniele Lacamera <root@danielinux.net>
 *
 *
 * Motenpoche is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Motenpoche is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1335, USA
 *
 */
#include <stdint.h>
#include "ui.h"
#include "display.h"
#include "bsp/board.h"
#include "fsm.h"
#include "ui.h"

static enum vault_state vault_state = VAULT_OFF;
static volatile int ui_event_pending = 0;
static enum vault_state old_st = 0;

void fsm_event_task(void)
{
    /* UI trigger */
    if (ui_event_pending) {
        ui_event_pending = 0;
        ui_event_cb(old_st, fsm_get());
    }
}

/* state transactions: actions */
void fsm_set(enum vault_state st)
{
    old_st = vault_state;

    if (st == vault_state)
        return;
    /* Change state */
    vault_state = st;
    ui_event_cb(old_st, fsm_get());
}

enum vault_state fsm_get(void)
{
    return vault_state;
}
